# frozen_string_literal: true

require 'commonmarker'

module CommonMarker
  # Compatibility with the RedCloth API.
  # @see https://github.com/vmg/redcarpet/blob/master/lib/redcarpet/compat.rb#L1
  class CompatRenderer
    attr_accessor :text

    DEFAULT_EXTENSIONS = %i[tagfilter autolink table strikethrough].freeze
    DEFAULT_OPTIONS = %i[GITHUB_PRE_LANG].freeze

    def initialize(text, *exts, options: DEFAULT_OPTIONS)
      @text = text
      @extensions = DEFAULT_EXTENSIONS + exts
      @options = options || DEFAULT_OPTIONS
    end

    # @return [String]
    attr_reader :text

    # @return [Symbol]
    attr_reader :options

    # @return [<Symbol>]
    attr_reader :extensions

    def to_html(*_dummy)
      CommonMarker.render_html(text, options, extensions)
    end
  end
end
